Index: pjproject/trunk/tests/pjsua/scripts-recvfrom/300_timer_good.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-recvfrom/300_timer_good.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-recvfrom/300_timer_good.py	(revision 5844)
@@ -5,5 +5,5 @@
 # INVITE session using session timer
 
-pjsua = "--null-audio sip:127.0.0.1:$PORT --use-timer 2 --timer-min-se 100 --timer-se 2000"
+pjsua = "--null-audio sip:127.0.0.1:$PORT --use-timer 2 --timer-min-se 100 --timer-se 2000 --no-tcp"
 
 req = sip.RecvfromTransaction("INVITE with session timer", 200,
Index: pjproject/trunk/tests/pjsua/scripts-recvfrom/301_timer_good_retry_after_422.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-recvfrom/301_timer_good_retry_after_422.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-recvfrom/301_timer_good_retry_after_422.py	(revision 5844)
@@ -6,5 +6,5 @@
 
 
-pjsua = "--null-audio sip:127.0.0.1:$PORT --timer-min-se 100 --timer-se 1000"
+pjsua = "--null-audio sip:127.0.0.1:$PORT --timer-min-se 100 --timer-se 1000 --no-tcp"
 
 # First INVITE with timer rejected with 422
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-183-without-to-tag.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-183-without-to-tag.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-183-without-to-tag.py	(revision 5844)
@@ -3,5 +3,5 @@
 import inc_const as const
 
-PJSUA = ["--null-audio --max-calls=1 $SIPP_URI"]
+PJSUA = ["--null-audio --max-calls=1 --no-tcp $SIPP_URI"]
 
 PJSUA_EXPECTS = [[0, "Audio updated", ""]]
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-200-reinvite-without-sdp.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-200-reinvite-without-sdp.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-200-reinvite-without-sdp.py	(revision 5844)
@@ -3,5 +3,5 @@
 import inc_const as const
 
-PJSUA = ["--null-audio --max-calls=1 $SIPP_URI"]
+PJSUA = ["--null-audio --max-calls=1 --no-tcp $SIPP_URI"]
 
 PJSUA_EXPECTS = [[0, const.STATE_CONFIRMED, "v"]]
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-200-update-without-sdp.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-200-update-without-sdp.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-answer-200-update-without-sdp.py	(revision 5844)
@@ -3,5 +3,5 @@
 import inc_const as const
 
-PJSUA = ["--null-audio --max-calls=1 $SIPP_URI"]
+PJSUA = ["--null-audio --max-calls=1 --no-tcp $SIPP_URI"]
 
 PJSUA_EXPECTS = [[0, const.STATE_CONFIRMED, "U"]]
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-cancel-no-final.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-cancel-no-final.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-cancel-no-final.py	(revision 5844)
@@ -3,5 +3,5 @@
 import inc_const as const
 
-PJSUA = ["--null-audio --max-calls=1 $SIPP_URI"]
+PJSUA = ["--null-audio --max-calls=1 --no-tcp $SIPP_URI"]
 
 PJSUA_EXPECTS = [[0, const.STATE_EARLY, "h"]]
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-glare.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-glare.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-glare.py	(revision 5844)
@@ -3,5 +3,5 @@
 import inc_const as const
 
-PJSUA = ["--null-audio --max-calls=1 $SIPP_URI"]
+PJSUA = ["--null-audio --max-calls=1 --no-tcp $SIPP_URI"]
 
 PJSUA_EXPECTS = [[0, const.STATE_CONFIRMED, "U"]]
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-with-less-media.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-with-less-media.py	(revision 5843)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-with-less-media.py	(revision 5844)
@@ -3,5 +3,5 @@
 import inc_const as const
 
-PJSUA = ["--null-audio --extra-audio --max-calls=1 $SIPP_URI"]
+PJSUA = ["--null-audio --extra-audio --max-calls=1 --no-tcp $SIPP_URI"]
 
 # Send hold after remote holds (double hold)