Index: /pjproject/trunk/pjsip/src/test/dns_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/dns_test.c	(revision 5847)
+++ /pjproject/trunk/pjsip/src/test/dns_test.c	(revision 5848)
@@ -51,5 +51,5 @@
     pj_dns_parsed_query q;
     pj_dns_parsed_rr ans[4];
-    pj_dns_parsed_rr ar[5];
+    pj_dns_parsed_rr ar[10];
     pj_str_t tmp;
     unsigned i;
@@ -73,4 +73,5 @@
      example.com.	3600 IN A       5.5.5.5
 
+     ; Additionally, add corresponding empty AAAA records for all A records
      */
     pj_bzero(&pkt, sizeof(pkt));
@@ -152,4 +153,12 @@
     ar[4].rdata.a.ip_addr = pj_inet_addr(pj_cstr(&tmp, "5.5.5.5"));
 
+    /* Add corresponding AAAA records for A records above */
+    for (i = 0; i < 5; ++i) {
+	ar[5+i].name = ar[i].name;
+	ar[5+i].type = PJ_DNS_TYPE_AAAA;
+	ar[5+i].dnsclass = PJ_DNS_CLASS_IN;
+	ar[5+i].ttl = 3600;
+    }
+
     /* 
      * Create individual A records for all hosts in "example.com" domain.
@@ -163,6 +172,9 @@
 	q.type = ar[i].type;
 	q.dnsclass = PJ_DNS_CLASS_IN;
-	pkt.hdr.anscount = 1;
-	pkt.ans = &ar[i];
+	/* For now, AAAA always contains empty record */
+	if (ar[i].type != PJ_DNS_TYPE_AAAA) {
+	    pkt.hdr.anscount = 1;
+	    pkt.ans = &ar[i];
+	}
 
 	pj_dns_resolver_add_entry( resv, &pkt, PJ_FALSE);
@@ -213,4 +225,6 @@
 	sip06.domain.com. 3600 IN A       6.6.6.6
 	sip07.domain.com. 3600 IN A       7.7.7.7
+
+        ; Additionally, add corresponding empty AAAA records for all A records
      */
 
@@ -268,4 +282,5 @@
 
     pkt.hdr.qdcount = 1;
+    pkt.hdr.anscount = 1;
     pkt.q = &q;
     q.name = ans[0].name;
@@ -274,4 +289,10 @@
 
     pj_dns_resolver_add_entry( resv, &pkt, PJ_FALSE);
+
+    /* Add corresponding AAAA record */
+    q.type = PJ_DNS_TYPE_AAAA;
+    pkt.hdr.anscount = 0;
+    pj_dns_resolver_add_entry( resv, &pkt, PJ_FALSE);
+
 
     /* Add the A record for sip07.domain.com */
@@ -283,4 +304,5 @@
 
     pkt.hdr.qdcount = 1;
+    pkt.hdr.anscount = 1;
     pkt.q = &q;
     q.name = ans[0].name;
@@ -289,4 +311,10 @@
 
     pj_dns_resolver_add_entry( resv, &pkt, PJ_FALSE);
+
+    /* Add corresponding AAAA record */
+    q.type = PJ_DNS_TYPE_AAAA;
+    pkt.hdr.anscount = 0;
+    pj_dns_resolver_add_entry( resv, &pkt, PJ_FALSE);
+
 
     pkt.hdr.qdcount = 0;
Index: /pjproject/trunk/pjsip/src/test/msg_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/msg_test.c	(revision 5847)
+++ /pjproject/trunk/pjsip/src/test/msg_test.c	(revision 5848)
@@ -1108,5 +1108,5 @@
 	/* Proxy-Authenticate, testing which params should be quoted */
 	"Proxy-Authenticate", NULL,
-	"Digest  realm=\"realm\",domain=\"sip:domain\",nonce=\"nonce\","  \
+	"Digest realm=\"realm\",domain=\"sip:domain\",nonce=\"nonce\","  \
 	        "opaque=\"opaque\",stale=true,algorithm=MD5,qop=\"auth\"",
 	&hdr_test_proxy_authenticate
Index: /pjproject/trunk/pjsip/src/test/tsx_basic_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/tsx_basic_test.c	(revision 5847)
+++ /pjproject/trunk/pjsip/src/test/tsx_basic_test.c	(revision 5848)
@@ -275,5 +275,5 @@
 	    &tsx_create_and_send_req,
 	    "sip:user@somehost",
-	    1,
+	    3000, /* Wait for DNS timeout, dec ref to the group lock is done in DNS+send callback */
 	    15000
 	},
@@ -289,5 +289,5 @@
 	    &tsx_create_and_send_req,
 	    "sip:user@10.125.36.63:58517;transport=tcp",
-	    1,
+	    22000, /* Wait for TCP connect timeout, dec ref to the group lock is done in send callback */
 	    60000
 	},
Index: /pjproject/trunk/pjsip/src/test/tsx_uas_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/tsx_uas_test.c	(revision 5847)
+++ /pjproject/trunk/pjsip/src/test/tsx_uas_test.c	(revision 5848)
@@ -1490,5 +1490,7 @@
 	{ 50, 10,   TEST10_BRANCH_ID, "test10: failed transport in TRYING state (50 ms delay)" },
 	{ 0,  1500, TEST11_BRANCH_ID, "test11: failed transport in PROCEEDING state (no delay)" },
-	{ 50, 1500, TEST11_BRANCH_ID, "test11: failed transport in PROCEEDING state (50 ms delay)" },
+	// After ticket #2076, transport error will be ignored if tsx is in COMPLETED state, note that
+	// tsx state will be shifted to COMPLETED state once 200 response is sent due to transport delay.
+	//{ 50, 1500, TEST11_BRANCH_ID, "test11: failed transport in PROCEEDING state (50 ms delay)" },
 	{ 0,  2500, TEST12_BRANCH_ID, "test12: failed transport in COMPLETED state (no delay)" },
 	//Not applicable (maybe)
@@ -1527,4 +1529,5 @@
 
 	pjsip_loop_set_failure(loop, 1, NULL);
+	PJ_LOG(5,(THIS_FILE, "   transport loop fail mode set"));
 
 	end_test = now;