Index: pjproject/trunk/tests/automated/android64-ipv6.xml.template
===================================================================
--- pjproject/trunk/tests/automated/android64-ipv6.xml.template	(revision 5859)
+++ pjproject/trunk/tests/automated/android64-ipv6.xml.template	(revision 5859)
@@ -0,0 +1,25 @@
+<?xml version="1.0" ?>
+<Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
+ 
+	<Submit group="Experimental" build="Android64-IPv6-video">
+		<Update />
+		<FileWrite file="user.mak">
+		  <![CDATA[
+# Written by ccdash
+export CFLAGS += -Wno-unused-label -g
+]]>			
+		</FileWrite>
+		<FileWrite file="pjlib/include/pj/config_site.h">
+		  <![CDATA[
+/* Written by ccdash */
+#define PJ_HAS_IPV6		1
+#define PJ_CONFIG_ANDROID	1
+#define PJMEDIA_HAS_VIDEO	1
+#include <pj/config_site_sample.h>
+]]>			
+		</FileWrite>
+		<Configure cmd="make distclean &amp;&amp; TARGET_ABI=arm64-v8a ./configure-android --use-ndk-cflags --with-openh264=/Users/pjsip/Desktop/opt-android-arm64" />
+		<Build cmd="make dep &amp;&amp; make clean &amp;&amp; make &amp;&amp; cd pjsip-apps/src/swig &amp;&amp; make clean &amp;&amp; make" />
+	</Submit>
+	
+</Scenario>
Index: pjproject/trunk/tests/automated/gnu-ipp.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 5858)
+++ pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 5859)
@@ -12,7 +12,9 @@
 		  <![CDATA[
 /* Written by ccdash */
-#define PJ_HAS_IPV6		1
 #define PJMEDIA_HAS_G7221_CODEC 0
 #define PJMEDIA_HAS_INTEL_IPP	1
+#define PJMEDIA_SRTP_HAS_DTLS	1
+// There has to be a test with IPv6 disabled
+#define PJ_HAS_IPV6		0
 ]]>			
 		</FileWrite>
Index: pjproject/trunk/tests/automated/gnu-video.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu-video.xml.template	(revision 5859)
+++ pjproject/trunk/tests/automated/gnu-video.xml.template	(revision 5859)
@@ -0,0 +1,31 @@
+<?xml version="1.0" ?>
+<Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
+ 
+	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-VideoFFmpeg-IPv6" exclude="(.*amr.*)">
+		<Update />
+		<FileWrite file="user.mak">
+		  <![CDATA[
+# Written by ccdash
+export CFLAGS += -Wno-unused-label -g -Wno-deprecated-declarations
+]]>			
+		</FileWrite>
+		<FileWrite file="pjlib/include/pj/config_site.h">
+		  <![CDATA[
+/* Written by ccdash */
+#define PJ_HAS_IPV6		1
+#define PJMEDIA_HAS_VIDEO	1
+#define PJMEDIA_HAS_G7221_CODEC 1
+#define PJMEDIA_SRTP_HAS_DTLS	1
+]]>			
+		</FileWrite>
+		<Configure cmd="make distclean &amp;&amp; ./0configure" />
+		<Build cmd="make dep &amp;&amp; make clean &amp;&amp; make" />
+		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" disabled=$(NOTEST) />
+		$(PJSUA-TESTS)
+	</Submit>
+	
+</Scenario>
Index: pjproject/trunk/tests/automated/gnu.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu.xml.template	(revision 5858)
+++ pjproject/trunk/tests/automated/gnu.xml.template	(revision 5859)
@@ -15,4 +15,5 @@
 #define PJ_HAS_IPV6		1
 #define PJMEDIA_HAS_G7221_CODEC 1
+#define PJMEDIA_SRTP_HAS_DTLS	1
 ]]>			
 		</FileWrite>
Index: pjproject/trunk/tests/automated/iphone64-ipv6.xml.template
===================================================================
--- pjproject/trunk/tests/automated/iphone64-ipv6.xml.template	(revision 5859)
+++ pjproject/trunk/tests/automated/iphone64-ipv6.xml.template	(revision 5859)
@@ -0,0 +1,24 @@
+<?xml version="1.0" ?>
+<Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
+ 
+	<Submit group="Experimental" build="iOS64-IPv6">
+		<Update />
+		<FileWrite file="user.mak">
+		  <![CDATA[
+# Written by ccdash
+export CFLAGS += -Wno-unused-label -g
+]]>			
+		</FileWrite>
+		<FileWrite file="pjlib/include/pj/config_site.h">
+		  <![CDATA[
+/* Written by ccdash */
+#define PJ_HAS_IPV6             1
+#define PJ_CONFIG_IPHONE	1
+#include <pj/config_site_sample.h>
+]]>			
+		</FileWrite>
+		<Configure cmd="make distclean &amp;&amp; ARCH='-arch arm64' ./configure-iphone" />
+		<Build cmd="make dep &amp;&amp; make clean &amp;&amp; make" />
+	</Submit>
+	
+</Scenario>
Index: pjproject/trunk/tests/automated/msvc.xml.template
===================================================================
--- pjproject/trunk/tests/automated/msvc.xml.template	(revision 5858)
+++ pjproject/trunk/tests/automated/msvc.xml.template	(revision 5859)
@@ -9,4 +9,5 @@
 #define PJ_HAS_IPV6		1
 #define PJMEDIA_HAS_G7221_CODEC 1
+#define PJMEDIA_SRTP_HAS_DTLS	1
 #define PJ_TODO(x)
 ]]>			